class Pettanr.View.FacedLabelButton extends Pettanr.View
  tagName: 'span'
  
  constructor: (@item, @label_options, @button_options) ->
    super()
  
  initialize: () ->
    @face_button = @item[@face_button_method_name()](@button_options)
    @label_button = @item.label_button(@label_options, @button_options)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@face_button.render().el)
    this.$el.append(@label_button.render().el)
    this
  
  face_button_method_name: () ->
    'face_button'
  
class Pettanr.View.MiniFacedLabelButton extends Pettanr.View.FacedLabelButton
  
  face_button_method_name: () ->
    'mini_face_button'
  
class Pettanr.View.FacedLabelButton.Error extends Pettanr.View
  tagName: 'span'
  
  constructor: () ->
    super()
  
  initialize: () ->
    k = @face_icon_class_name()
    @face_icon = new k(Pettanr.View.Image.icon_error_file())
    @label = I18n.t('yasapp.unresolved')
  
  render: () ->
    this.$el.html('')
    this.$el.append(@face_icon.render().el)
    this.$el.append(@label.render().el)
    this
  
  face_icon_class_name: () ->
    Pettanr.View.Icon
  
class Pettanr.View.MiniFacedLabelButton.Error extends Pettanr.View.FacedLabelButton.Error
  
  face_icon_class_name: () ->
    Pettanr.View.Minicon
  
