# filer's edit box
class Pettanr.Views.OriginalPicture.Publish extends Pettanr.View
  
  initialize: (options) ->
    super(options)
    @file_item = options.file_item
    @my_manifest = options.my_manifest
    @item = options.item
  
  render: () ->
    this.$el.html('')
    if @is_own()
      @item.get_child('resource_picture', this, {
        success: (@resource_picture) =>
          if @resource_picture
            @stop_button = new Pettanr.View.Button.ItemAction(@resource_picture, 'destroy', 'original_pictures.index.stop', {
              context: this, 
              click: () =>
                return if !confirm('remove?')
                proxy = new Pettanr.Proxy({})
                @listenTo(proxy, 'success', @remove_success)
                @listenTo(proxy, 'fail', @remove_fail)
                @listenTo(proxy, 'deny', @remove_deny)
                proxy.http_post(@resource_picture.destroy_url())
            })
            this.$el.append(@stop_button.render().el)
          @edit_button = @item.mini_edit_button({
            context: this, 
            click: () ->
              @trigger('http_get', @item.edit_url())
          })
          @destroy_button = @item.mini_destroy_button({
            context: this, 
            click: () ->
              @trigger('remove')
          })
          this.$el.append(@edit_button.render().el)
          this.$el.append(@destroy_button.render().el)
      })
    this
  
  is_own: () ->
    if @item.is_own()
      true
    else
      false
   
  filer: () ->
    @file_item.filer()
  
  manifest: () ->
    @filer().manifest
  
  item_name: () ->
    @filer().item_name
  
  remove_success: () ->
    @trigger('update')
  
  remove_fail: () ->
    # no update
  
  remove_deny: () ->
  
