class Author < Peta::Owner
  load_manifest
  belongs_to :user
  has_many :scrolls
  has_many :comics
  has_many :sheets
  has_many :panels
  
  validates :name, :presence => true, :length => {:maximum => 30}
  validates :user_id, :numericality => true, :existence => {:both => false}
  
  scope :find_index, -> do
    self
  end
  
  def supply_default
    self.name = 'no name' if self.name.blank?
    self.user_id = nil
  end
  
  def self.show_opt
    {:include => {:user => {:artist => {}}} }
  end
  
end
