module Locmare
  module DialogModule
    module BodyModule
      module FileBodyModule
        module FileItemModule
          module ButtonItemColumnModule
            class Base
              attr :file_item, :button_manifest, :item, :column_name
              
              def initialize file_item, button_manifest, item
                @file_item = file_item
                @button_manifest = button_manifest
                @item = item
                @column_name = 'button'
              end
              
              def filer
                @file_item.filer
              end
              
              def manifest
                self.filer.manifest
              end
              
              def item_name
                self.filer.item_name
              end
              
              def image_dir
                self.filer.image_dir
              end
              
              def column_template_dir
                self.filer.template_dir + 'item_column/'
              end
              
              def column_template_file_name
                raise "undefined column_template_file_name\n"
              end
              
              def column_template_name
                self.column_template_dir + self.column_template_file_name
              end
              
              def item_template_dir
                self.filer.template_dir + 'button/'
              end
              
              def item_template_file_name
                raise "undefined item_template_file_name\n"
              end
              
              def item_template_name
                self.item_template_dir + self.item_template_file_name
              end
              
            end
            
            class Default < Base
              def column_template_file_name
                'show'
              end
              
              def item_template_file_name
                'default'
              end
              
              def pickup_img_file_name
                self.image_dir + 'pickup.png'
              end
              
              def img_opt
                {:width => Manifest.manifest.magic_numbers['thumbnail_width'] / 2, 
                  :height => Manifest.manifest.magic_numbers['thumbnail_height'] / 2}
              end
              
              def pickup_img_opt
                img_opt.merge :src => self.pickup_img_file_name
              end
              
            end
            
          end
        end
      end
    end
  end
end
