require_dependency "locmare/filer/body/file_header/base"
require_dependency "locmare/filer/body/file_header/show"
require_dependency "locmare/filer/body/file_header/none"
module Locmare
  module FilerModule
    module BodyModule
      class FileHeader
        include FileHeaderModule
        
        attr :body,
          :symbol, :caption, :summary, :icon, :date, :edit
        def initialize body
          @body = body
          c = self.filer.manifest.symbol.visible? ? Show : None
          @symbol = c.new self, 'symbol'
          c = self.filer.manifest.caption.visible? ? Show : None
          @caption = c.new self, 'caption'
          c = self.filer.manifest.summary.visible? ? Show : None
          @summary = c.new self, 'summary'
          c = self.filer.manifest.icon.visible? ? Show : None
          @icon = c.new self, 'icon'
          c = self.filer.manifest.date.visible? ? Show : None
          @date = c.new self, 'date'
          c = self.filer.manifest.edit.visible? ? Show : None
          @edit = c.new self, 'edit'
        end
        
        def filer
          @body.filer
        end
        
        def manifest
          self.filer.manifest
        end
        
        def item_name
          self.filer.item_name
        end
        
        def model
          self.filer.model
        end
        
        def items
          self.filer.items
        end
        
        def template_dir
          @body.template_dir
        end
        
        def template_file_name
          "file_header"
        end
        
        def template_name
          self.template_dir + self.template_file_name
        end
        
      end
    end
  end
end
