require_dependency "locmare/profiler/column/base"
require_dependency "locmare/profiler/column/default"
require_dependency "locmare/profiler/column/date"
require_dependency "locmare/profiler/column/source"
require_dependency "locmare/profiler/column/extend"
require_dependency "locmare/profiler/column/json"
module Locmare
  module ProfilerModule
    class Column
      include ColumnModule
      @@types = {
        'default' => Default, 'date' => Date, 'source' => Source, 
        'extend' => Extend, 'json' => Json
      }
      def self.factory profiler, my_manifest
        type = my_manifest.type
        raise "undefined type for local view filers > #{profiler.item_name} > edit\n" unless type
        my_class = @@types[type]
        raise "undefined class for local view filers > #{profiler.item_name} > edit > #{type}\n" unless my_class
        my_class.new(profiler,  my_manifest)
      end
      
    end
  end
end

