module Locmare
  module ProfilerModule
    module ColumnModule
      class Base
        attr :profiler, :column_name
        def initialize profiler, column_manifest
          @profiler = profiler
          @column_manifest = column_manifest
          @column_name = @column_manifest.name
        end
        
        def label
          self.item.class.human_attribute_name(@column_name)
        end
        
        def value
          self.item.attributes[@column_name]
        end
        
        def item
          @profiler.item
        end
        
        def template_dir 
          @profiler.template_dir + "column/"
        end
        
        def template_file_name
          "default"
        end
        
        def template_name
          self.template_dir + self.template_file_name
        end
        
        def value_template_dir 
          @profiler.template_dir + "column_value/"
        end
        
        def value_template_file_name
          'default'
        end
        
        def value_template_name
          self.value_template_dir + self.value_template_file_name
        end
        
      end
    end
  end
end
