# -*- encoding: utf-8 -*-
FactoryGirl.define do
  factory :author_yas, :class => Author do |i|
    i.name 'ペン次郎'
    association :user, factory: :user_yas
    ignore do
      scrolls_count 5
    end
    trait :with_scrolls do
      after(:create) do |author, evaluator|
        create_list(:scroll_hello, evaluator.scrolls_count, author: author)
      end
    end
    trait :with_contents do
      after(:create) do |author, evaluator|
        panel_hello = create(:panel_hello, author: author)
        scroll_hello = create(:scroll_hello, author: author)
        scroll_hello_panel_hello = create(:scroll_hello_panel_hello, scroll: scroll_hello, panel: panel_hello)
      end
    end
    factory :yas_with_scrolls, traits: [:with_scrolls]
    factory :yas_with_contents , traits: [:with_contents]
  end
  factory :author_itojun, :class => Author do |i|
    i.name 'itojun'
  end
  factory :author003, :class => Author do |i|
    i.name 'qqqqqq'
  end
  factory :author004, :class => Author do |i|
    i.name 'やる気満々'
  end
  factory :author005, :class => Author do |i|
    i.name 'z6'
  end
end
